from Const import *
from ConfigUtils import *
from DownloadFile import DownloadFile
import DownloadFileListLock
from threading import Lock

class DownloadFileList:

    def __init__(self):
        self.downloadFileList = []
        self.completedFileList = []
        #self.downloadFileListLock = None
        #self.completedFileListLock = None

    #def setLock(self):
        #DownloadFileListLock.downloadFileListLock = Lock()
        #DownloadFileListLock.completedFileListLock = Lock()

    def unsetLock(self):
        DownloadFileListLock.downloadFileListLock.acquire()
        for downloadFile in self.downloadFileList:
            downloadFile.removeDownloadParts()
        DownloadFileListLock.downloadFileListLock.release()
        DownloadFileListLock.completedFileListLock.acquire()
        for downloadFile in self.completedFileList:
            downloadFile.removeDownloadParts()
        DownloadFileListLock.completedFileListLock.release()
        #self.downloadFileListLock = None
        #self.completedFileListLock = None



    def getList(self, getCompletedList = None):
        if (getCompletedList == None):
            return self.downloadFileList
        else:
            return self.completedFileList

    def addQueueingFile(self, downloadFile):
        DownloadFileListLock.downloadFileListLock.acquire()
        self.downloadFileList.append(downloadFile)
        DownloadFileListLock.downloadFileListLock.release()

    def getQueueingFile(self):
        #print ' size of self.downloadFileList is ', len (self.downloadFileList)
        DownloadFileListLock.downloadFileListLock.acquire()
        for downloadFile in self.downloadFileList:
            #if (downloadFile.getStatus() == STAT_Q or (downloadFile.getStatus() == STAT_E and downloadFile.isRetryPossible())):
            #print 'Checking ', downloadFile.getFileURL(), ' status ', downloadFile.getStatus(), ' retryposible ', downloadFile.isRetryPossible()
            if (downloadFile.getStatus() == STAT_Q and downloadFile.isRetryPossible()):
                DownloadFileListLock.downloadFileListLock.release()
                return downloadFile
        #print 'NO Queueing file retriable found, return NONE'
        DownloadFileListLock.downloadFileListLock.release()
        return None


    def deleteDownloadFileFromDownloadList(self, id, moveToCompleted = None):
        i = 0
        DownloadFileListLock.downloadFileListLock.acquire()
        for downloadFile in self.downloadFileList:
            if (downloadFile.getId() == id):
                if (moveToCompleted == None):
                    del self.downloadFileList[i]
                else:
                    downloadFile = self.downloadFileList.pop(i)
                    DownloadFileListLock.completedFileListLock.acquire()
                    self.completedFileList.append(downloadFile)
                    DownloadFileListLock.completedFileListLock.release()
                break
            i += 1
        DownloadFileListLock.downloadFileListLock.release()



    def deleteDownloadFileFromCompletedList(self, id, moveToDownload = None):
        i = 0
        DownloadFileListLock.completedFileListLock.acquire()
        for downloadFile in self.completedFileList:
            if downloadFile.getId() == id:
                if moveToDownload is None:
                    del self.completedFileList[i]
                    DownloadFileListLock.completedFileListLock.release()
                    return
                else:
                    downloadFile = self.completedFileList.pop(i)
                    DownloadFileListLock.downloadFileListLock.acquire()
                    self.downloadFileList.append(downloadFile)
                    DownloadFileListLock.downloadFileListLock.release()
                    DownloadFileListLock.completedFileListLock.release()
                    return
            i += 1
        DownloadFileListLock.completedFileListLock.release()



    def getNumberOfDownloadingFile(self):
        i = 0
        DownloadFileListLock.downloadFileListLock.acquire()
        for downloadFile in self.downloadFileList:
            if (downloadFile.getStatus() == STAT_D):
                i += 1
        DownloadFileListLock.downloadFileListLock.release()
        return i


    def getNumberOfQueueingFile(self):
        i = 0
        DownloadFileListLock.downloadFileListLock.acquire()
        for downloadFile in self.downloadFileList:
            if (downloadFile.getStatus() == STAT_Q and downloadFile.isRetryPossible()):
                i += 1
        DownloadFileListLock.downloadFileListLock.release()
        return i


    def resetStatus(self, status):
        DownloadFileListLock.downloadFileListLock.acquire()
        for downloadFile in self.downloadFileList:
            if (downloadFile.getStatus() != STAT_D):
                #print 'Reseting', downloadFile.getFileURL(), ' to ', status
                downloadFile.setStatus(status)
                downloadFile.setErrorStr('')
        DownloadFileListLock.downloadFileListLock.release()


    def getDownloadFileById(self, id, fromQueueingList = True):
        if fromQueueingList:
            DownloadFileListLock.downloadFileListLock.acquire()
            for downloadFile in self.downloadFileList:
                if (downloadFile.getId() == id):
                    DownloadFileListLock.downloadFileListLock.release()
                    return downloadFile
            DownloadFileListLock.downloadFileListLock.release()
        else:
            DownloadFileListLock.completedFileListLock.acquire()
            for downloadFile in self.completedFileList:
                if (downloadFile.getId() == id):
                    DownloadFileListLock.completedFileListLock.release()
                    return downloadFile
            DownloadFileListLock.completedFileListLock.release()


    def getDownloadFileByFileURL(self, fileURL, fromQueueingList = True):
        if fromQueueingList:
            DownloadFileListLock.downloadFileListLock.acquire()
            for downloadFile in self.downloadFileList:
                if (downloadFile.getFileURL() == fileURL):
                    DownloadFileListLock.downloadFileListLock.release()
                    return downloadFile
            DownloadFileListLock.downloadFileListLock.release()


    def changeStatus(self, id, status):
        self.getDownloadFileById(id).setStatus(status)


    def emptyList(self):
        DownloadFileListLock.downloadFileListLock.acquire()
        self.downloadFileList = []
        DownloadFileListLock.downloadFileListLock.release()


    def saveToFile(self):
        queueingFile = open(Config.settings.queueingListFile, 'wb')
        #print dir(self.downloadFileList)
        DownloadFileListLock.completedFileListLock.acquire()
        DownloadFileListLock.downloadFileListLock.acquire()
        cPickle.dump(self, queueingFile, cPickle.HIGHEST_PROTOCOL)
        DownloadFileListLock.downloadFileListLock.release()
        DownloadFileListLock.completedFileListLock.release()
        queueingFile.close()
